com.fasterxml.jackson.databind.ser.std

## Class AsArraySerializerBase<T>

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<T>
      - - com.fasterxml.jackson.databind.ser.std.AsArraySerializerBase<T>

- All Implemented Interfaces:
    JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable
  Direct Known Subclasses:
    CollectionSerializer, EnumSetSerializer, IndexedListSerializer, IterableSerializer, IteratorSerializer

      public abstract class AsArraySerializerBase<T>
      extends ContainerSerializer<T>
      implements ContextualSerializer

  Base class for serializers that will output contents as JSON arrays; typically serializers used for `Collection` and array types.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `JsonSerializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected PropertySerializerMap` | `_dynamicSerializers` If element type cannot be statically determined, mapping from runtime type to serializer is handled using this object
    `protected JsonSerializer<Object>` | `_elementSerializer` Value serializer to use, if it can be statically determined
    `protected JavaType` | `_elementType`
    `protected BeanProperty` | `_property` Collection-valued property being serialized with this instance
    `protected boolean` | `_staticTyping`
    `protected Boolean` | `_unwrapSingle` Setting for specific local override for "unwrap single element arrays": true for enable unwrapping, false for preventing it, `null` for using global configuration.
    `protected TypeSerializer` | `_valueTypeSerializer` Type serializer used for values, if any.

    - ### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_handledType`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AsArraySerializerBase(AsArraySerializerBase<?> src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer)` Deprecated. since 2.6: use the overloaded method that takes 'unwrapSingle'
    `protected` | `AsArraySerializerBase(AsArraySerializerBase<?> src, BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer, Boolean unwrapSingle)`
    `protected` | `AsArraySerializerBase(Class<?> cls, JavaType et, boolean staticTyping, TypeSerializer vts, BeanProperty property, JsonSerializer<Object> elementSerializer)` Deprecated. Since 2.6 Use variants that either take 'src', or do NOT pass BeanProperty
    `protected` | `AsArraySerializerBase(Class<?> cls, JavaType et, boolean staticTyping, TypeSerializer vts, JsonSerializer<Object> elementSerializer)` Non-contextual, "blueprint" constructor typically called when the first instance is created, without knowledge of property it was used via.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected JsonSerializer<Object>` | `_findAndAddDynamic(PropertySerializerMap map, Class<?> type, SerializerProvider provider)`
    `protected JsonSerializer<Object>` | `_findAndAddDynamic(PropertySerializerMap map, JavaType type, SerializerProvider provider)`
    `void` | `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
    `JsonSerializer<?>` | `createContextual(SerializerProvider serializers, BeanProperty property)` This method is needed to resolve contextual annotations like per-property overrides, as well as do recursive call to `createContextual` of content serializer, if known statically.
    `JsonSerializer<?>` | `getContentSerializer()` Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
    `JavaType` | `getContentType()` Accessor for finding declared (static) element type for type this serializer is used for.
    `JsonNode` | `getSchema(SerializerProvider provider, Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
    `void` | `serialize(T value, JsonGenerator gen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
    `protected abstract void` | `serializeContents(T value, JsonGenerator gen, SerializerProvider provider)`
    `void` | `serializeWithType(T value, JsonGenerator g, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
    `AsArraySerializerBase<T>` | `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer)` Deprecated. since 2.6: use the overloaded method that takes 'unwrapSingle'
    `abstract AsArraySerializerBase<T>` | `withResolved(BeanProperty property, TypeSerializer vts, JsonSerializer<?> elementSerializer, Boolean unwrapSingle)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

      `_withValueTypeSerializer, hasContentTypeAnnotation, hasSingleElement, withValueTypeSerializer`

    - ### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

      `_neitherNull, _nonEmpty, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findContextualConvertingSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

      `getDelegatee, isEmpty, isEmpty, isUnwrappingSerializer, properties, replaceDelegatee, unwrappingSerializer, usesObjectId, withFilterId`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _elementType

          protected final JavaType _elementType

    - #### _property

          protected final BeanProperty _property

      Collection-valued property being serialized with this instance

    - #### _staticTyping

          protected final boolean _staticTyping

    - #### _unwrapSingle

          protected final Boolean _unwrapSingle

      Setting for specific local override for "unwrap single element arrays": true for enable unwrapping, false for preventing it, `null` for using global configuration.
      Since:
        2.6

    - #### _valueTypeSerializer

          protected final TypeSerializer _valueTypeSerializer

      Type serializer used for values, if any.

    - #### _elementSerializer

          protected final JsonSerializer<Object> _elementSerializer

      Value serializer to use, if it can be statically determined

    - #### _dynamicSerializers

          protected PropertySerializerMap _dynamicSerializers

      If element type cannot be statically determined, mapping from runtime type to serializer is handled using this object

  - ### Constructor Detail

    - #### AsArraySerializerBase

          protected AsArraySerializerBase(Class<?> cls,
                                          JavaType et,
                                          boolean staticTyping,
                                          TypeSerializer vts,
                                          JsonSerializer<Object> elementSerializer)

      Non-contextual, "blueprint" constructor typically called when the first instance is created, without knowledge of property it was used via.
      Since:
        2.6

    - #### AsArraySerializerBase

          @Deprecated
          protected AsArraySerializerBase(Class<?> cls,
                                                      JavaType et,
                                                      boolean staticTyping,
                                                      TypeSerializer vts,
                                                      BeanProperty property,
                                                      JsonSerializer<Object> elementSerializer)

      Deprecated. Since 2.6 Use variants that either take 'src', or do NOT pass BeanProperty

    - #### AsArraySerializerBase

          protected AsArraySerializerBase(AsArraySerializerBase<?> src,
                                          BeanProperty property,
                                          TypeSerializer vts,
                                          JsonSerializer<?> elementSerializer,
                                          Boolean unwrapSingle)

    - #### AsArraySerializerBase

          @Deprecated
          protected AsArraySerializerBase(AsArraySerializerBase<?> src,
                                                      BeanProperty property,
                                                      TypeSerializer vts,
                                                      JsonSerializer<?> elementSerializer)

      Deprecated. since 2.6: use the overloaded method that takes 'unwrapSingle'

  - ### Method Detail

    - #### withResolved

          @Deprecated
          public final AsArraySerializerBase<T> withResolved(BeanProperty property,
                                                                         TypeSerializer vts,
                                                                         JsonSerializer<?> elementSerializer)

      Deprecated. since 2.6: use the overloaded method that takes 'unwrapSingle'

    - #### withResolved

          public abstract AsArraySerializerBase<T> withResolved(BeanProperty property,
                                                                TypeSerializer vts,
                                                                JsonSerializer<?> elementSerializer,
                                                                Boolean unwrapSingle)

      Since:
        2.6

    - #### createContextual

          public JsonSerializer<?> createContextual(SerializerProvider serializers,
                                                    BeanProperty property)
                                             throws JsonMappingException

      This method is needed to resolve contextual annotations like per-property overrides, as well as do recursive call to `createContextual` of content serializer, if known statically.
      Specified by:
        `createContextual` in interface `ContextualSerializer`
      Parameters:
        `serializers` - Serializer provider to use for accessing config, other serializers
        `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
      Returns:
        Serializer to use for serializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### getContentType

          public JavaType getContentType()

      Description copied from class: `ContainerSerializer`
      Accessor for finding declared (static) element type for type this serializer is used for.
      Specified by:
        `getContentType` in class `ContainerSerializer<T>`

    - #### getContentSerializer

          public JsonSerializer<?> getContentSerializer()

      Description copied from class: `ContainerSerializer`
      Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.
      Specified by:
        `getContentSerializer` in class `ContainerSerializer<T>`

    - #### serialize

          public void serialize(T value,
                                JsonGenerator gen,
                                SerializerProvider provider)
                         throws IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles.
      Specified by:
        `serialize` in class `StdSerializer<T>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `gen` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
      Throws:
        `IOException`

    - #### serializeWithType

          public void serializeWithType(T value,
                                        JsonGenerator g,
                                        SerializerProvider provider,
                                        TypeSerializer typeSer)
                                 throws IOException

      Description copied from class: `JsonSerializer`
      Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

      Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

      For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

            // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
            typeSer.writeTypePrefixForScalar(value, gen);
            serialize(value, gen, provider);
            typeSer.writeTypeSuffixForScalar(value, gen);

      and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY`/`END-ARRAY` and `START-OBJECT`/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.
      Overrides:
        `serializeWithType` in class `JsonSerializer<T>`
      Parameters:
        `value` - Value to serialize; can not be null.
        `g` - Generator used to output resulting Json content
        `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
        `typeSer` - Type serializer to use for including type information
      Throws:
        `IOException`

    - #### serializeContents

          protected abstract void serializeContents(T value,
                                                    JsonGenerator gen,
                                                    SerializerProvider provider)
                                             throws IOException

      Throws:
        `IOException`

    - #### getSchema

          public JsonNode getSchema(SerializerProvider provider,
                                    Type typeHint)
                             throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation simply claims type is "string"; usually overriden by custom serializers.
      Specified by:
        `getSchema` in interface `SchemaAware`
      Overrides:
        `getSchema` in class `StdSerializer<T>`
      Parameters:
        `provider` - The serializer provider.
        `typeHint` - A hint about the type.
      Returns:
        Json-schema for this serializer.
      Throws:
        `JsonMappingException`

    - #### acceptJsonFormatVisitor

          public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                                              JavaType typeHint)
                                       throws JsonMappingException

      Description copied from class: `StdSerializer`
      Default implementation specifies no format. This behavior is usually overriden by custom serializers.
      Specified by:
        `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
      Overrides:
        `acceptJsonFormatVisitor` in class `StdSerializer<T>`
        `typeHint` - Type of element (entity like property) being visited
      Throws:
        `JsonMappingException`

    - #### _findAndAddDynamic

          protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                                    Class<?> type,
                                                                    SerializerProvider provider)
                                                             throws JsonMappingException

      Throws:
        `JsonMappingException`

    - #### _findAndAddDynamic

          protected final JsonSerializer<Object> _findAndAddDynamic(PropertySerializerMap map,
                                                                    JavaType type,
                                                                    SerializerProvider provider)
                                                             throws JsonMappingException

      Throws:
        `JsonMappingException`

Copyright © 2008–2019 FasterXML. All rights reserved.